package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;

import java.util.Arrays;

public class BlockBreakListener implements Listener {
    @EventHandler
    static void onBlockBreak(BlockBreakEvent event) {
        Location blockLocation = event.getBlock().getLocation();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(blockLocation.getWorld())) {
            PixelBlock pixelBlock = PixelBlock.getPixelBlockFromWorld(blockLocation.getWorld());

            assert pixelBlock != null;
            pixelBlock.handleBlockBreak(event, true);
        }
    }
}
