package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.Arrays;
import java.util.UUID;

public class BlockPlaceListener implements Listener {
    @EventHandler
    static void onBlockPlace(BlockPlaceEvent event) {
        if(event.getItemInHand().getItemMeta().getDisplayName().contains("Pixelblock")
                && !event.getItemInHand().getItemMeta().getItemName().isEmpty()
                && event.getItemInHand().getItemMeta().getEnchantmentGlintOverride()) {
            event.setCancelled(true);

            World playerWorld = event.getPlayer().getWorld();
            World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1)};

            if(Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
                Location newBlockLocation = event.getBlock().getLocation();

                if(event.getItemInHand().getItemMeta().getItemName().equals("Pixelblock")) {
                    ItemMeta newMeta = event.getItemInHand().getItemMeta();
                    newMeta.setItemName(UUID.randomUUID().toString());
                    event.getItemInHand().setItemMeta(newMeta);
                }

                PixelBlock pixelBlock = new PixelBlock(newBlockLocation, event.getPlayer().getUniqueId(), UUID.fromString(event.getItemInHand().getItemMeta().getItemName()));
                pixelBlock.place(newBlockLocation);

                event.getPlayer().getInventory().remove(event.getItemInHand());
            } else {
                event.getPlayer().sendMessage("Du kannst nur in der Overworld oder im Nether Pixelblocks platzieren!");
            }
        } else {
            Location blockLocation = event.getBlock().getLocation();
            World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

            if(!Arrays.stream(standardWorlds).toList().contains(blockLocation.getWorld())) {
                PixelBlock pixelBlock = PixelBlock.getPixelBlockFromWorld(blockLocation.getWorld());

                assert pixelBlock != null;
                pixelBlock.handleBlockPlace(event, true);
            }
        }
    }
}
