package eu.mhsl.minecraft.pixelblocks.listeners;

import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.*;
import org.bukkit.inventory.CraftingInventory;
import org.bukkit.inventory.PlayerInventory;

import java.util.Arrays;
import java.util.Objects;

public class InventoryListener implements Listener {
    @EventHandler
    static void onInventoryOpen(InventoryOpenEvent event) {
        World playerWorld = event.getPlayer().getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryDrag(InventoryDragEvent event) {
        World playerWorld = event.getWhoClicked().getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryClick(InventoryClickEvent event) {
        World playerWorld = event.getWhoClicked().getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryInteract(InventoryInteractEvent event) {
        World playerWorld = event.getWhoClicked().getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            if(!(event.getInventory() instanceof PlayerInventory) && !(event.getInventory() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    static void onInventoryMoveItem(InventoryMoveItemEvent event) {
        World playerWorld = Objects.requireNonNull(event.getDestination().getLocation()).getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            if(!(event.getDestination() instanceof PlayerInventory) && !(event.getDestination() instanceof CraftingInventory)) {
                event.setCancelled(true);
            }
        }
    }
}
