package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import io.papermc.paper.event.player.PrePlayerAttackEntityEvent;
import org.bukkit.*;
import org.bukkit.entity.Interaction;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerInteractEntityEvent;

public class PlayerInteractListener implements Listener {
    @EventHandler
    static void onPlayerInteractEntity(PlayerInteractEntityEvent event) {
        if(event.getRightClicked() instanceof Interaction) {
            Location interactionLocation = event.getRightClicked().getLocation().clone().add(0, PixelBlock.hitboxOffset, 0).toBlockLocation();
            interactionLocation.setYaw(0);
            interactionLocation.setPitch(0);

            PixelBlock pixelBlock = PixelBlock.getPixelBlockFromLocation(interactionLocation);

            assert pixelBlock != null;
            pixelBlock.handleInteraction(event.getPlayer());
        }
    }

    @EventHandler
    static void onPlayerAttackEntity(PrePlayerAttackEntityEvent event) {
        if(event.getAttacked() instanceof Interaction) {
            Location blockLocation = event.getAttacked().getLocation().add(0, PixelBlock.hitboxOffset, 0).toBlockLocation();
            blockLocation.setYaw(0);
            blockLocation.setPitch(0);

            PixelBlock pixelBlock = PixelBlock.getPixelBlockFromLocation(blockLocation);

            assert pixelBlock != null;
            pixelBlock.handleAttack(event.getPlayer());
        }
    }
}
