package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;

import java.util.Arrays;

public class PlayerMoveListener implements Listener {
    @EventHandler
    static void onPlayerMove(PlayerMoveEvent event) {
        World playerWorld = event.getPlayer().getWorld();
        World[] standardWorlds = {Bukkit.getWorlds().get(0), Bukkit.getWorlds().get(1), Bukkit.getWorlds().get(2)};

        if(!Arrays.stream(standardWorlds).toList().contains(playerWorld)) {
            Location playerLocation = event.getPlayer().getLocation();
            PixelBlock pixelBlock = PixelBlock.getPixelBlockFromWorld(playerWorld);
            assert pixelBlock != null;
            Location portalLocation = pixelBlock.getPortalLocation().clone();

            if(playerLocation.y() < -65) {
                event.getPlayer().teleport(pixelBlock.getPlayerSpawnLocation(event.getPlayer()));
            } else if(playerLocation.getZ() < portalLocation.getZ()+1
                && playerLocation.getZ() > portalLocation.getZ()) {
                if(playerLocation.getX() < portalLocation.getX()+3
                    && playerLocation.getX() > portalLocation.getX()+1) {
                    if(playerLocation.getY() < portalLocation.getY()+4
                        && playerLocation.getY() > portalLocation.getY()+1) {
                        event.getPlayer().teleport(pixelBlock.lastEntryLocation);
                    }
                }
            }
        }
    }
}
